#include <Arduino.h>
#include <HardwareSerial.h>

#define SERIAL1             1
#define SERIAL2             2

HardwareSerial              ESP32Serial1(SERIAL1);
#define COMPORT             ESPSerial1

// Module functions
void comportInit(long lBaudrate);
int comportReceive(byte* pMsg, int nLen);
void comportTransmit(byte* pMsg, int nMsgLen);

// Message buffer design
#define MSGBUFFERSIZE       80;
byte pData[MSGBUFFERSIZE};

void setup() 
{
    // Initialize the Serial Port
    void comportInit(9600);

}

void loop() 
{
    // Just an example of usage
    int nBytes = comportReceive(&pData[0], MSGBUFFERSIZE);

    if(nBytes > 0)
        comportTransmit(&pData[0], nBytes);
}
// ------------------------------------------------------------------------------------------------------
// comportInit
// ------------------------------------------------------------------------------------------------------
void comportInit(long lBaudrate)
{
    COMPORT.begin(lBaudrate, SERIAL_8N1, 16, 17);       // Pins 16, 17 are assigned to the ESPSerial1 port
    
}// end comportInit

// ------------------------------------------------------------------------------------------------------
// comportReceive
// ------------------------------------------------------------------------------------------------------
// pMsg = Message buffer
// nLen = Message buffer length
//
int comportReceive(byte* pMsg, int nLen)
{
    // Declarations
    int nBytes = 0;
    
    // Read serial data
    while(COMPORT.available() > 0)
    {
        pMsg[nBytes++] = (byte)COMPORT.read();
        if(nBytes >= nLen)
            break;

    }// end while
    
    return nBytes;
  
}// end comportReceive

// ------------------------------------------------------------------------------------------------------
// comportTransmit
// ------------------------------------------------------------------------------------------------------
// pMsg = Message buffer
// nMsgLen = Message buffer length
//
void comportTransmit(byte* pMsg, int nMsgLen)
{
    // Transmit the data
    COMPORT.write(pMsg, nMsgLen);

}// end comportTransmit
